#include "log/df_log_check.h"
#if defined(_MSC_VER) || defined(__MINGW32__)
//#include <direct.h>
#include <io.h>

#include <cstdio>
//#include <time.h>
//#include <string>
#include <set>
#include <functional>

typedef std::greater<std::string> sf;
typedef std::multiset<std::string, sf> ms;
typedef ms::iterator msIterator;
#endif

CDFLogCheck::CDFLogCheck()
{
}

CDFLogCheck::~CDFLogCheck()
{
}

int CDFLogCheck::Check()
{
#if defined(_MSC_VER) || defined(__MINGW32__)
    int j;
    char szFile[260];

    j = 0;
    ms theSet;
    msIterator theIterator;
    // Suche nach Logdateien
    std::sprintf( szFile, LOG_SEARCH_FILENAME, m_base_path, m_sub_folder );
    intptr_t fp;
    struct _finddata_t finddata;
    // Passende Dateien fuer Muster?
    if ( (fp = _findfirst( szFile, &finddata )) != -1 )
    {
        // Alle Dateien in einem Set sammeln.
        do
        {
            theSet.insert( finddata.name );

        } while ( _findnext(fp, &finddata) != -1 );

        _findclose( fp );
    }

    // Suche nach Listendateien
    std::sprintf( szFile, LOG_SEARCH_LIST_FILENAME, m_base_path, m_sub_folder );
    // Passende Dateien fuer Muster?
    if ( (fp = _findfirst( szFile, &finddata )) != -1 )
    {
        // Alle Dateien in einem Set sammeln.
        do
        {
            theSet.insert( finddata.name );

        } while ( _findnext( fp, &finddata ) != -1 );

        _findclose( fp );
    }

    // Sind Dateien verfuegbar.
    if ( !theSet.empty() )
    {
        char tmp[11] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        // Alle Dateien durchgehen
        for ( ; !theSet.empty() ; )
        {
            theIterator = theSet.begin();

            // Ist Datei von selbigem Datum?
            if ( std::strncmp( tmp, theIterator->data(), 10 ) == 0 )
            {
                // Datei mit gleichem Datums-Zeichenfolgenbeginn
                // Kann sein, da fuer verschiedene Kanaele gelogt werden kann.
            }
            else
            {
                // Datums-Zeichenfolge des Dateinamen aufnehmen.
                std::strncpy( tmp, theIterator->data(), 10 );

                j++; // Zu erhaltende Datei
            }

            // Datumsbereich der zu erhaltenden Dateien ueberschritten?
            if ( j > m_erase_file_days )
            {
                std::sprintf( szFile, LOG_DELETE_FILENAME, m_base_path, m_sub_folder, theIterator->data() );

                if ( ::remove( szFile ) == -1 )
                {
                    // Konnte nicht geloescht werden!
                }

//				TRACE("(%2i)Erase file: %s\n", j, theIterator->data());
            }
            else
            {

//				TRACE("(%2i)Hold file: %s\n", j, theIterator->data());
            }

            // Datei aus Set entfernen
            theSet.erase( theIterator );
        }
    }

#endif
    return 1;
}
